
from django.shortcuts import render,redirect
from django.http import HttpResponse
import requests
import json

from rest_framework import response

from employees.forms import EmployeeForm


def EmployeeListView2(request):
    response = requests.get("http://127.0.0.1:3399/api/employees/")
    return HttpResponse(response.text)

def EmployeeListView(request):
    response = requests.get("http://127.0.0.1:3399/api/employees/")

    # response = requests.get("http://127.0.0.1:3399/app/employees/list/")


    if response.status_code == 200:
        try:
            employee_list = json.loads(response.text)
        except:
            context = {
                "message" : "Sorry, Accessed data not available in JSON format"
            }
            return render(request, 'employees/employee_list.html', context)
        else:
            context = {
                "employee_list" : employee_list
            }
            return render(request, 'employees/employee_list.html', context)
    elif response.status_code == 404:
        context = {
            "message" : "Requested resources not available to display"
        }
        return render(request, 'employees/employee_list.html', context)
    else:
        context = {
            "message" : "Something Wrong"
        }
        return render(request, 'employees/employee_list.html', context)

def EmployeeDetailView(request,pk):
    response = requests.get("http://127.0.0.1:3399/api/employees/"+str(pk)+"/")
    if response.status_code == 200:
        try:
            employee = json.loads(response.text)
        except:
            context = {
                "message" : "Sorry, you are unable to access data by using this API"
            }
            return render(request, 'employees/employee_detail.html', context)
        else:
            context = {
                "employee" : employee
            }
            return render(request, 'employees/employee_detail.html', context)
    elif response.status_code == 404:
        context = {
            "message" : "Requested resource not available to display"
        }
        return render(request, 'employees/employee_detail.html', context)
    else:
        context = {
            "message" : "Something Wrong"
        }
        return render(request, 'employees/employee_detail.html', context)


def EmployeeDeleteView(request,pk):
    response = requests.delete("http://127.0.0.1:3399/api/employees/"+str(pk)+"/")
    if response.status_code == 204:
        return redirect("employee_list")

    elif response.status_code == 404:
        context = {
            "message" : "Requested resource not available to deleting"
        }
        return render(request, 'employees/employee_delete.html', context)
    else:
        context = {
                "message" : "Something Wrong"
        }
        return render(request, 'employees/employee_delete.html', context)




def EmployeeCreateView(request):
    if request.method == "POST":
        form = EmployeeForm(request.POST)
        if form.is_valid():
            # ename = request.POST.get('ename')
            # salary = request.POST.get('salary')
            # city = request.POST.get('city')
            # mobile = request.POST.get('mobile')

            employee_object = {
                "ename" : request.POST.get('ename'),
                "salary" : request.POST.get('salary'),
                "city" : request.POST.get('city'),
                "mobile" : request.POST.get('mobile')
            }
            response = requests.post("http://127.0.0.1:3399/api/employees/", employee_object)
            if response.status_code == 201:
                return redirect("employee_list")
                '''
                try:
                    employee_list = json.loads(response.text)
                except:
                    context = {
                        "message": "Accessed response is not available in JSON format"
                    }
                    return render(request, 'employees/employee_form.html', context)
                else:
                    context = {
                        "employee_list": employee_list
                    }
                    return render(request, 'employees/employee_form.html', context)
                    '''

            elif response.status_code == 400:
                context = {
                    "message" : "Requested resource  is not creating in database"
                }
                return render(request, 'employees/employee_form.html', context)
            else:
                context = {
                    "message" : "Something Wrong"
                }
                return render(request, 'employees/employee_form.html', context)

        else:
            context = {
                "message" : "Form object data is not valid data"
            }
            return render(request, 'employees/employee_form.html', context)

    else:
        form = EmployeeForm()
        context = {
            "form" : form
        }
        return render(request, 'employees/employee_form.html', context)


def EmployeeUpdateview(request,pk):
    if request.method =='POST':
        form = EmployeeForm(request.POST)
        if form.is_valid():
            # ename = request.POST.get('ename')
            # salary = request.POST.get('salary')
            # city = request.POST.get('city')
            # mobile = request.POST.get('mobile')

            employee_object = {
                "ename": request.POST.get('ename'),
                "salary": request.POST.get('salary'),
                "city": request.POST.get('city'),
                "mobile": request.POST.get('mobile')
            }
            response = requests.put("http://127.0.0.1:3399/api/employees/"+str(pk)+"/", employee_object)
            if response.status_code == 200:
                return redirect("employee_list")
            elif response.status_code == 400:
                context = {
                    "message" : "Requested resource  is not updating in database"
                }
                return render(request, 'employees/employee_update.html', context)
            else:
                context = {
                    "message" : "Something Wrong"
                }
                return render(request, 'employees/employee_update.html', context)


    else:
        response = requests.get("http://127.0.0.1:3399/api/employees/" + str(pk) + "/")
        if response.status_code == 200:
            try:
                employee = json.loads(response.text)
            except:
                context = {
                    "message": "Sorry, Accessed data is not available in JSON format"
                }
                return render(request, 'employees/employee_update.html', context)
            else:
                # form = EmployeeForm(employee)
                # context = {
                #     "form" : form
                # }
                # return render(request, 'employees/employee_update.html', context)


                context = {
                    "employee": employee
                }
                return render(request, 'employees/employee_update.html', context)

        elif response.status_code == 404:
            context = {
                "message": "Requested resource not available to update"
            }
            return render(request, 'employees/employee_update.html', context)
        else:
            context = {
                "message": "Something Wrong"
            }
            return render(request, 'employees/employee_update.html', context)



























